//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UExcel.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

#include "Shldisp.h"
#include "sysutils.hpp"
#include "stdio.h"

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GetVariant(AnsiString str, VARIANT &var)
{
    DWORD strlen = 0;
    BSTR  strptr;

    strlen = MultiByteToWideChar(CP_ACP, 0, str.c_str(), -1, 0, 0);
    strptr = SysAllocStringLen(0, strlen);
    MultiByteToWideChar(CP_ACP, 0, str.c_str(), -1, strptr, strlen);

    VariantInit(&var);
    var.vt = VT_BSTR;
    var.bstrVal = strptr;
}


bool __fastcall TForm1::UnZipFile(AnsiString SourceDir, AnsiString SourceFile, AnsiString DestDir)
{
    bool b = false;
	HRESULT hResult = S_FALSE;
	IShellDispatch *pISD = NULL;
    IDispatch *d = NULL;
	Folder *pToFolder = NULL, *pFromFolder = NULL, *pCurrentFolder = NULL;
    FolderItems *fi = NULL;
    FolderItem *item = NULL;
	VARIANT vSrc, vDest, vOptions, vItem, vIndex;
    long count = 0, OldCount = 0;
    BSTR name;
    AnsiString ItemName, MatchItem, MatchStr = SourceFile;
    bool found = true;
    int pos;
    short is_folder = 0;

	CoInitialize(NULL);

    VariantInit(&vOptions);
    vOptions.vt = VT_I4;
    vOptions.lVal = 0x0004;  // FOF_SILENT don't create progress/report

    VariantInit(&vItem);
    vItem.vt = VT_DISPATCH;

    VariantInit(&vIndex);
    vIndex.vt = VT_I4;

    hResult = CoCreateInstance(CLSID_Shell, NULL, CLSCTX_INPROC_SERVER, IID_IShellDispatch, (void **)&pISD);

	if (SUCCEEDED(hResult) && pISD != NULL) {

        GetVariant(DestDir, vDest);
		hResult = pISD->NameSpace(vDest, &pToFolder);

		if  (SUCCEEDED(hResult) && pToFolder != NULL) {

            GetVariant(SourceDir, vSrc);
			hResult = pISD->NameSpace(vSrc, &pFromFolder);

            if  (SUCCEEDED(hResult) && pFromFolder != NULL) {

                pFromFolder->Items(&fi);

                //   Item-
                fi->get_Count(&count);
                while(found == true && MatchStr.IsEmpty() == false) {
                    found = false;
                    if((pos = MatchStr.Pos('\\')) > 0 ) {
                        MatchItem = MatchStr.SubString(1, pos - 1);
                        MatchStr = MatchStr.SubString(pos + 1, MatchStr.Length() - pos);
                    } else {
                        MatchItem = MatchStr;
                        MatchStr = "";
                    }
                    for(long i = 0; i < count; i++) {
                        vIndex.lVal = i;
                        fi->Item(vIndex, &item);
                        item->get_Path(&name);
                        ItemName = name;
                        if((pos = ItemName.LastDelimiter('\\')) > 0) {
                            ItemName = ItemName.SubString(pos + 1, ItemName.Length() - pos);
                        }
                        if(ItemName == MatchItem) {
                            found = true;
                            break;
                        }
                    }
                }

                if(found == true) {
                    vItem.pdispVal = item;
                } else {
                    vItem.pdispVal = fi;
                }

                pToFolder->Items(&fi);
                fi->get_Count(&OldCount);
                hResult = pToFolder->MoveHere(vItem, vOptions);

                //   .
                while( true )
                {
                    Sleep(100);

                    fi = NULL;
                    pToFolder->Items(&fi);
                    fi->get_Count(&count);

                    Application->ProcessMessages();

                    if( count > OldCount ) {
                        break;
                    }
                }

                pFromFolder->Release();
            }
            pToFolder->Release();
		}
		pISD->Release();
	}

	CoUninitialize();

    return b;
}


_di_IXMLNode __fastcall TForm1::FindChildNode( _di_IXMLNode node, AnsiString FoundName )
{
    bool found = false;
    _di_IXMLNode xNode = NULL, FoundNode = NULL;
    _di_IXMLNodeList xChildNodes;
    AnsiString NodeName;

    xChildNodes = node->GetChildNodes();
    for (int i = 0; i < xChildNodes->Count; i++) {
        xNode = xChildNodes[0][i];
        NodeName = AnsiString(xNode->NodeName);
        if(NodeName == FoundName) {
            FoundNode = xNode;
            break;
        }
    }

    return FoundNode;
}


_di_IXMLNode __fastcall TForm1::FindNodeAttr(
    _di_IXMLNode node, AnsiString NodeName, AnsiString AttrName, AnsiString Value
)
{
    bool found = false;
    _di_IXMLNode xNode = NULL, FoundNode = NULL;
    _di_IXMLNodeList xChildNodes;
    AnsiString CurrentName, CurrentAttr;

    xChildNodes = node->GetChildNodes();
    for (int i = 0; i < xChildNodes->Count; i++) {
        xNode = xChildNodes[0][i];
        CurrentName = AnsiString(xNode->NodeName);
        if(CurrentName == NodeName) {
            //   
            CurrentAttr = AnsiString(xNode->Attributes[AttrName]);
            if(CurrentAttr == Value) {
                FoundNode = xNode;
                break;
            }
        }
    }

    return FoundNode;
}


//      NodeStr
// (   , : "aaa\bbb\ccc\ddd")
//
_di_IXMLNode __fastcall TForm1::FindNode( _di_IXMLNode parent, AnsiString NodeStr )
{
    AnsiString S = NodeStr, X;
    _di_IXMLNode n = parent, r = NULL;
    int p;

    while (n != NULL) {
        if((p = S.Pos("\\")) == 0) {
            //   
            r = n->ChildNodes->FindNode(S, L"");
            break;
        } else {
            X = S.SubString(1, p - 1);
            S = S.SubString(p + 1, S.Length() - p);
            n = n->ChildNodes->FindNode(X, L"");
        }
    }

    return r;
}


void __fastcall TForm1::ParseCellRowCol(AnsiString Cell, int &row, int &col)
{
    int i, cp = 1, rp = 1;
    const char* c = Cell.c_str();

    row = col = 0;
    for(i=0; c[i] != '\0'; i++);
    for(i = i - 1; i >= 0; i--) {
        if(c[i] >= '1' && c[i] <= '9') {
            row += (c[i] - '0') * rp;
            rp *= 10;
        } else if(c[i] >= 'A' && c[i] <= 'Z') {
            col += (c[i] - 'A' + 1) * cp;
            cp *= 26;
        } else if(c[i] >= 'a' && c[i] <= 'z') {
            col += (c[i] - 'a' + 1) * cp;
            cp *= 26;
        }
    }
}

AnsiString __fastcall TForm1::GetRowName(AnsiString CellName)
{
    int row, col;
    AnsiString X;

    ParseCellRowCol(CellName, row, col);
    X.sprintf("%i", row);

    return X;
}


bool __fastcall TForm1::SetNodeValue(_di_IXMLNode parent, AnsiString NodeName, AnsiString Value)
{
    bool b = false;

    try {
        _di_IXMLNode n = FindNode( parent, NodeName );
        if(n == NULL) {
            n = parent->AddChild(NodeName.c_str(), L"", false);
        }
        if(n != NULL) {
            n->Text = Value.c_str();
            b = true;
        }
    } catch(...) {}

    return b;
}


_di_IXMLNode __fastcall TForm1::FindCellNode(_di_IXMLDocument xmlDoc, AnsiString CellName)
{
    _di_IXMLNode xNode = NULL, xRoot;
    AnsiString RowName = GetRowName(CellName);

    if ((xRoot = xmlDoc->DocumentElement) == NULL) {
        ; //  
    } else if((xNode = FindNode( xRoot, "sheetData" )) == NULL) {
        ; //  
    } else if((xNode = FindNodeAttr( xNode, "row", "r", RowName )) == NULL) {
        ; //   
    } else {
        //  
        xNode = FindNodeAttr( xNode, "c", "r", CellName );
    }
    return xNode;
}


bool __fastcall TForm1::SaveXml(_di_IXMLDocument xmlDoc, AnsiString FileName)
{
    AnsiString X, OldFile;

    X = StringReplace(xmlDoc->XML->Text, " xmlns=\"\"", "", TReplaceFlags()<< rfReplaceAll << rfIgnoreCase); //  ' xlmns=""'
//        xmlDoc->SaveToFile( FileName ); //  ,    xlmns, xmlDoc    ,   
//        xmlDoc->XML->Text = X;
    OldFile.sprintf("%s.1", FileName.c_str());
    if(RenameFile(FileName, OldFile) == true) {
        FILE* f;
        f = fopen(FileName.c_str(), "wb");
        fclose(f);
        f = fopen(FileName.c_str(), "a+");
        fputs(X.c_str(), f);
        fclose(f);
        DeleteFile(OldFile.c_str());
    }
}


//    'S'  sharedStrings.xml
//     .
//
AnsiString __fastcall TForm1::SetSharedStrings(
    _di_IXMLDocument xmlDoc, AnsiString S
)
{
    _di_IXMLNode xNode = NULL, xRoot;
    AnsiString R, X;
    int Count, UniqueCount;
    _di_IXMLNodeList xChildNodes;

    if ((xRoot = xmlDoc->DocumentElement) == NULL) {
        ; //  
    } else {
        Count = AnsiString(xRoot->Attributes["count"]).ToIntDef(0);
        UniqueCount = AnsiString(xRoot->Attributes["uniqueCount"]).ToIntDef(0);
        xChildNodes = xRoot->GetChildNodes();
        for (int i = 0; i < xChildNodes->Count; i++) {
            xNode = xChildNodes[0][i];
            xNode = xNode->ChildNodes->FindNode(S, L"t");
            if(xNode != NULL) {
                X = xNode->Text;
                if(X == S) {
                    R.sprintf("%i", i); //  
                    X.sprintf("%i", Count + 1);
                    xRoot->Attributes["count"] = X;
                    break;
                }
            }
        }
        if(R.IsEmpty() == true) {
            //     
            if((xNode = xRoot->AddChild("si", L"", false)) != NULL) { //   "si"
                if((xNode = xNode->AddChild("t", L"", false)) != NULL) { //   "t"
                    xNode->Text = S.c_str();
                    R.sprintf("%i", UniqueCount);
                    X.sprintf("%i", UniqueCount + 1);
                    xRoot->Attributes["uniqueCount"] = X;
                    X.sprintf("%i", Count + 1);
                    xRoot->Attributes["count"] = X;
                }
            }
        }
    }

    return R;
}


//   'CellName'
// (  ,   'Value').
// ! Value   'sharedStrings.xml',
//        'sharedStrings'
//
bool __fastcall TForm1::EditCell(
    _di_IXMLDocument xmlSheet1, _di_IXMLDocument xmlSharedStrings
    , AnsiString CellName, AnsiString Value
)
{
    _di_IXMLNode xNode;
    AnsiString StrIndex;
    bool b = false;

    if ((xNode = FindCellNode(xmlSheet1, CellName)) == NULL) {
        ; //   
    } else if((StrIndex = SetSharedStrings(xmlSharedStrings, Value)).IsEmpty() == true) {
        ; //    sharedStrings.xml
    } else {
        xNode->Attributes["t"] = AnsiString("s");
        b = SetNodeValue( xNode, "v", StrIndex );
    }

    return b;
}


AnsiString __fastcall TForm1::GetUnique()
{
    AnsiString X;
    GUID g;
    wchar_t* buf;

    try{
        CoCreateGuid(&g);
        buf = new wchar_t[100];
        StringFromGUID2(g, buf, 100);
        X = AnsiString(buf);
        delete [] buf;
    }catch(...) {}

    return X;
}


int __fastcall TForm1::ReversePos(const AnsiString S, const AnsiString Match)
{
    int p = 0, n = S.Length();
    for (int i = S.Length(); i > 0; i--) {
        if(S.SubString(i, 1) == Match && i != n) {
            p = i;
            break;
        }
    }
    return p;
}

void __fastcall TForm1::AssertDir(const AnsiString p)
{
   if (::GetFileAttributes(p.c_str()) == INVALID_FILE_ATTRIBUTES) {             //   ...
      int i = ReversePos(p, "\\");                                                  //  ,  
      if (i > 0) {
         AssertDir(p.SubString(1, i - 1));
      }
      ::CreateDirectory(p.c_str(), NULL);                                           //  
   }
}


AnsiString __fastcall GetFileName(AnsiString FileName)
{
    AnsiString X, R;

    X.sprintf("%s", FileName.c_str());
    if(X.Pos("\\") > 0 || X.Pos(":") > 0) {
        //   , ,  
        R = X;
    } else {
        //  ,   
        R.sprintf("%s%s"
            , ExtractFilePath(Application->ExeName).c_str()
            , X.c_str()
        );
    }
    return R;
}


void __fastcall TForm1::B_DoItClick(TObject *Sender)
{
    AnsiString SourceDir, SourceFile;
    AnsiString DestDir, DestFile;
    AnsiString ZipName, DestZip;
    AnsiString Unique, TempDir;
    AnsiString WorksheetsPath = "xl\\worksheets";
    AnsiString sharedStringsPath = "xl";
    AnsiString nameSheet1 = "sheet1.xml", nameSharedStrings = "sharedStrings.xml";
    AnsiString Worksheets, SharedStrings;
    AnsiString fileNameSheet1, fileNameSharedStrings;
    AnsiString X;
    int pos;
    bool b = false;
    _di_IXMLDocument xmlSheet1, xmlSharedStrings;

    if(E_SourceFile->Text.IsEmpty() == true) {
        ShowMessage("Source File  ");
    } else if ( E_DestFile->Text.IsEmpty() == true ) {
        ShowMessage("Dest File  ");
    } else if ( E_TempDir->Text.IsEmpty() == true ) {
        ShowMessage("Temp Dir  ");
    } else {
        SourceFile = GetFileName(E_SourceFile->Text);
        //    
        if(FileExists(SourceFile) == false) {
            X.sprintf("  : %s", SourceFile.c_str());
            ShowMessage(X);
            return ;
        }

        //   
        Unique = GetUnique();
        TempDir.sprintf("%s\\%s", E_TempDir->Text.c_str(), Unique.c_str());
        AssertDir(TempDir);

        //       (   xlsx -->  zip)
        SourceFile.sprintf("%s", E_SourceFile->Text.c_str());
        if(FileExists(SourceFile) == true) {
            X = ExtractFileName(SourceFile);
            if((pos = X.Pos(".")) > 0) {
                X = X.SubString(1, pos - 1);
            }
            ZipName.sprintf("%s\\%s.zip", TempDir.c_str(), X.c_str());
            CopyFile(SourceFile.c_str(), ZipName.c_str(), TRUE);
        }

        //   'Sheet1.xml'  
        Worksheets.sprintf("%s\\%s", ZipName.c_str(), WorksheetsPath.c_str());
        UnZipFile(Worksheets, nameSheet1, TempDir);

        //   'sharedStrings.xml'  
        SharedStrings.sprintf("%s\\%s", ZipName.c_str(), sharedStringsPath.c_str());
        UnZipFile(SharedStrings, nameSharedStrings, TempDir);

        //  'Sheet1.xml'
        xmlSheet1 = NewXMLDocument();
        fileNameSheet1.sprintf("%s\\%s", TempDir.c_str(), nameSheet1.c_str());
        if(FileExists(fileNameSheet1) == true) {
            xmlSheet1->LoadFromFile( fileNameSheet1 );
        }

        //  'sharedStrings.xml'
        xmlSharedStrings = NewXMLDocument();
        fileNameSharedStrings.sprintf("%s\\%s", TempDir.c_str(), nameSharedStrings.c_str());
        if(FileExists(fileNameSharedStrings) == true) {
            xmlSharedStrings->LoadFromFile( fileNameSharedStrings );
        }

        //  'Sheet1.xml'
        b = EditCell(xmlSheet1, xmlSharedStrings, E_Cell->Text, E_Value->Text);

        //  'Sheet1.xml'
        if(b == true) {
            SaveXml(xmlSheet1, fileNameSheet1);
            SaveXml(xmlSharedStrings, fileNameSharedStrings);
        }

        //     'Sheet1.xml'
        UnZipFile(TempDir, nameSheet1, Worksheets);

        //     'sharedStrings.xml'
        UnZipFile(TempDir, nameSharedStrings, SharedStrings);

        //  ,   (   zip -->  xlsx)
        DestFile = GetFileName(E_DestFile->Text);
        if(FileExists(DestFile) == true) {
            ::DeleteFile(DestFile.c_str());
        }
        if(FileExists(DestFile) == false) {
            MoveFile(ZipName.c_str(), DestFile.c_str());
        }

        //   
        ::RemoveDirectory(TempDir.c_str());

        // ,  
        ShowMessage("Done");
    }
}
//---------------------------------------------------------------------------
